-----------------------------------------------------------------------------------------------
-- Client Lua Script for Wulfys_GuildInviter
-- Copyright (c) NCsoft. All rights reserved
-- This is version 1.0 alpha and I take no responsibility for any consequences from this addon.
-- Use this addon at your own discretion and risk.
-----------------------------------------------------------------------------------------------
 
require "Window"
require "Apollo"
require "GameLib"
require "Unit"
require "GroupLib"
require "FriendshipLib"
require "ICCommLib"
 

local Wulfys_GuildInviter = {} 
 

function Wulfys_GuildInviter:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 



    return o
end

function Wulfys_GuildInviter:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 


function Wulfys_GuildInviter:OnLoad()
	self.xmlDoc = XmlDoc.CreateFromFile("Wulfys_GuildInviter.xml")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
	self.tAreaUnits = {}	
	self.tUnitTag = {}		
	self.tTagOption = {
				strFont = "Header4",	
				strFontColor = "red",	
				strRole = "NewSprite:healer", 
				nTagExpire = 30,	
				bFactionSet = false
			  }	

	self.uLastPlayer = nil  
	tz_bTrack = false     
	self.tUnitsBacklog = {}
	self.uPlayerUnit = nil
	Apollo.RegisterSlashCommand("wulfyinvite", "WulfyShowForm", self)
	Apollo.RegisterSlashCommand("wulfyinviterebuildlist", "RebuildTextList", self)
	Apollo.RegisterSlashCommand("wulfyinviteron", "TurnOn", self)
	Apollo.RegisterSlashCommand("wulfyinviteroff", "TurnOff", self)
	self.wndWulfyShowForm = Apollo.LoadForm("Wulfys_GuildInviter.xml", "WulfyInviteListForm", nil, self)
	self.wndWulfyShowForm :Show(false)
--	RebuildTextList()
--	Apollo.RegisterEventHandler("UnitEnteredCombat", "OnEnteredCombat", self)	
	Apollo.RegisterEventHandler("UnitCreated", "OnUnitCreated", self)		
--	Apollo.RegisterEventHandler("UnitDestroyed", "OnUnitDestroyed", self)
--	Apollo.RegisterEventHandler("ChangeWorld", "OnChangeWorld", self)	
--	Apollo.RegisterTimerHandler("Unit_Refresh", "OnTimerRefresh", self)
	--Apollo.CreateTimer("Unit_Refresh", 0.1, true)
--	Apollo.RegisterTimerHandler("Timer_Arrow", "OnTimerArrow", self)				


		
	self.playerList = {}
	self.onOff = false;
	self.listLengthText = self.wndWulfyShowForm:FindChild("ListLengthText")
	self.displayList = ""
end

function Wulfys_GuildInviter:WulfyShowForm()
	self.wndWulfyShowForm:Show(true)

end


function Wulfys_GuildInviter:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.wndMain = Apollo.LoadForm(self.xmlDoc, "Wulfys_GuildInviterForm", nil, self)

	end
end

function Wulfys_GuildInviter:RebuildTextList()
	for key,value in pairs (self.playerList) do
			
			--	if(unit:GetName() == value) then
				--	canSend = false
			--		break
			--	end
			--if(canSend == true) then
			--	ChatSystemLib.Command('/ginvite '..unit:GetName())
			--	table.insert(self.playerList, unit:GetName())
			--self.displayList = ""
			self.displayList = os.date("%c")..": Invite has been sent to "..value..'\n'..self.displayList
				--self:UpdateDisplayList()
			--end
				
					
			end
			self:UpdateDisplayList()
end
function Wulfys_GuildInviter:OnTimer()
	-- Do your timer-related stuff here.
end


function Wulfys_GuildInviter:OnOK()
	self.wndMain:Close() -- hide the window
end


function Wulfys_GuildInviter:OnCancel()
	self.wndMain:Close() -- hide the window
end


function Wulfys_GuildInviter:OnUnitCreated(unit)

	if(self.onOff == true) then
		local nUnitId = unit:GetId()
		
	    if (unit == nil) or (not unit:IsACharacter()) or (unit:IsThePlayer()) then return end
		
		if self.tAreaUnits[nUnitId] == nil then
	
				self.tAreaUnits[nUnitId] = {
								name =		unit:GetName(),					
								class =		unit:GetClassId(),				
								incombat =	false					
									   }
			local canSend = true
			for key,value in pairs (self.playerList) do
			
				if(unit:GetName() == value) then
					canSend = false
					break
				end
			--	if(GameLib.GetRealmName() ~= unit.GetRealmName()) then
			--		canSend = false;
			--	break
			--	end
				
					
			end
			if(canSend == true) then
				ChatSystemLib.Command('/ginvite '..unit:GetName())
				table.insert(self.playerList, unit:GetName())
				self.displayList = os.date("%c")..": Invite has been sent to "..unit:GetName()..'\n'..self.displayList
				self:UpdateDisplayList()
			end
		end 
	end
end
function Wulfys_GuildInviter:UpdateDisplayList()
	self.listLengthText:SetText("Invite List Length: "..table.getn(self.playerList))
--	if(self.displayList ~= nil) then
	
		self.invitesSentList = self.wndWulfyShowForm:FindChild("InvitesSentList"):SetText(self.displayList)
--	end

	self:UpdateButtonDisplay()

end

function Wulfys_GuildInviter:ClearList()
	self.playerList = {}
	self.displayList = ""
	self:UpdateDisplayList()
end
function Wulfys_GuildInviter:UpdateButtonDisplay()

	if(self.onOff == true) then
		self.wndWulfyShowForm:FindChild("ButtonOnOff"):SetText("Turn Off");
		self.wndWulfyShowForm:FindChild("ButtonOnOff"):SetBGColor("red");
		self.wndWulfyShowForm:FindChild("InviterOnOffText"):SetText("On");
		self.wndWulfyShowForm:FindChild("InviterOnOffText"):SetTextColor("green");
	else
		self.wndWulfyShowForm:FindChild("ButtonOnOff"):SetText("Turn On");
		self.wndWulfyShowForm:FindChild("ButtonOnOff"):SetBGColor("green");
		self.wndWulfyShowForm:FindChild("InviterOnOffText"):SetText("Off");
		self.wndWulfyShowForm:FindChild("InviterOnOffText"):SetTextColor("red");
	end
end
function Wulfys_GuildInviter:TurnOn()
	self.onOff = true
	self:UpdateButtonDisplay()
end
function Wulfys_GuildInviter:TurnOff()
	self.onOff = false
	self:UpdateButtonDisplay()
end

function Wulfys_GuildInviter:TurnOnOff()
	if(self.onOff == false) then
	
		self.onOff = true
		
	else
		self.onOff = false
		
	end
	self:UpdateButtonDisplay()
	
	
end
function Wulfys_GuildInviter:OnSave(eLevel)
--	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then InviterOnOffText
   --     return nil
--    end
	local saveData = { 
		--playerList  = self.playerList:GetSaveData(),
		--test = "cris"
	}
	saveData.playerList = self.playerList
	saveData.onOff = self.onOff
	saveData.displayList = self.displayList

	
	return saveData
	
end
function Wulfys_GuildInviter:OnRestore(eLevel, tData)
	self.playerList = {}
	--if tData.saved ~= nil then
		self.playerList = tData.playerList
		self.onOff = tData.onOff
		self:UpdateDisplayList()
		self.displayList = tData.displayList
		--self:UpdateDisplayList()
		
	--end
end

function Wulfys_GuildInviter:LoadSaveData(tData)
	if tData.playerList then
		self.playerList:Load(tData.playerList)
		self.onOff:Load(tData.onOff)
	end

	
end










-----------------------------------------------------------------------------------------------
-- Wulfys_GuildInviter Instance
-----------------------------------------------------------------------------------------------
local Wulfys_GuildInviterInst = Wulfys_GuildInviter:new()
Wulfys_GuildInviterInst:Init()
